/// <reference types="node" />
import https = require('https');
import { Merge } from 'type-fest';
import { Defaults, NormalizedOptions, Options, URLOrOptions } from './utils/types';
export declare const preNormalizeArguments: (options: Options, defaults?: NormalizedOptions | undefined) => NormalizedOptions;
export declare const mergeOptions: (...sources: Options[]) => NormalizedOptions;
export declare const normalizeArguments: (url: URLOrOptions, options?: Options | undefined, defaults?: Defaults | undefined) => NormalizedOptions;
export declare type NormalizedRequestArguments = Merge<https.RequestOptions, {
    body?: ReadableStream;
    url: Pick<NormalizedOptions, 'url'>;
}>;
export declare const normalizeRequestArguments: (options: NormalizedOptions) => Promise<Merge<https.RequestOptions, {
    body?: ReadableStream<any> | undefined;
    url: Pick<NormalizedOptions, "url">;
}>>;
